function textEntered(event) {
	var text = event.target.value;
	debug('textEntered('+text+')');
	var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
	                           .getService(Components.interfaces.nsIRDFService);
	var ds = RDFService.GetDataSourceBlocking(text);
	handleDataSource(ds);
	//ds.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	//ds.addXMLSinkObserver(rdfLoadObserver);
}

function debug(msg) {
	dump('rdfdump.js: '+msg+'\n');
}

var rdfLoadObserver = {
	onBeginLoad : function(sink){},
	onInterrupt : function(sink){},
	onResume : function(sink){},
	onError : function(sink,status,msg){},
	onEndLoad : function(sink) {
		this.debug('onEndLoad('+sink.URI+')');
		// Load datasource
		sink.removeXMLSinkObserver(this);
		sink.QueryInterface(Components.interfaces.nsIRDFDataSource);
		handleDataSource(sink);
	},
	debug : function(msg) {
		debug('rdfLoadObserver: '+msg);
	}
};

function handleDataSource(ds) {
	var localFile = Components.classes["@mozilla.org/file/directory_service;1"]
	                          .getService(Components.interfaces.nsIProperties)
	                          .get("ProfD", Components.interfaces.nsILocalFile);
	localFile.append('temp.rdf');
	var ioService = Components.classes["@mozilla.org/network/io-service;1"]
	                          .getService(Components.interfaces.nsIIOService);
	var localFileURI = ioService.newFileURI(localFile);
	ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	ds.FlushTo(localFileURI.spec);
	document.getElementById('content').setAttribute('src', 'view-source:'+localFileURI.spec);
}
